#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === ImageParadise::ConfreeGenerator
# =========================================================================== #
# require 'image_paradise/confree_generator/constants.rb'
# =========================================================================== #
require 'image_paradise/base/base.rb'

module ImageParadise

class ConfreeGenerator < ::ImageParadise::Base # === ImageParadise::ConfreeGenerator

  # ========================================================================= #
  # === NAMESPACE
  # ========================================================================= #
  NAMESPACE = inspect

  # ========================================================================= #
  # === CREATE_A_HTML_GALLERY
  # ========================================================================= #
  CREATE_A_HTML_GALLERY = true

  # ========================================================================= #
  # === ALPHABET
  # ========================================================================= #
  ALPHABET = ('a'..'z').to_a

  # ========================================================================= #
  # === TRY_TO_OPEN_THE_GENERATED_IMAGE_IN_THE_BROWSER
  # ========================================================================= #
  TRY_TO_OPEN_THE_GENERATED_IMAGE_IN_THE_BROWSER = true

  # ========================================================================= #
  # === DIRECTORY_FOR_THE_TEMPORARY_IMAGES
  # ========================================================================= #
  DIRECTORY_FOR_THE_TEMPORARY_IMAGES =
    '/Depot/Images/'

  # ========================================================================= #
  # === NAME_OF_OUTPUT_FILE
  # ========================================================================= #
  NAME_OF_OUTPUT_FILE = 'output.png'

  # ========================================================================= #
  # === OPTIMIZE_THE_PNG_FILES
  #
  # If this constant is set to true, then we will try to run
  # "pngquant" on the generated .png file.
  # ========================================================================= #
  OPTIMIZE_THE_PNG_FILES = true

  # ========================================================================= #
  # === YOUR_FAVOURITE_EDITOR
  #
  # Your favourite editor comes here. Perhaps you may prefer vim or
  # emacs.
  # ========================================================================= #
  YOUR_FAVOURITE_EDITOR = 'bluefish'

  # ========================================================================= #
  # === DIRECTORY_CONTAINING_THE_CFDG_FILES
  # ========================================================================= #
  DIRECTORY_CONTAINING_THE_CFDG_FILES =
    "#{ImageParadise.project_base_dir?}cfdg/"

  # ========================================================================= #
  # === MAY_WE_GENERATE_THE_IMAGE
  #
  # If this constant is false, then we will NOT generate any images.
  #
  # But we will auto-generate the html parts still.
  # ========================================================================= #
  MAY_WE_GENERATE_THE_IMAGE = true

  # ========================================================================= #
  # The height and width settings should not be too large because
  # otherwise the generated image files may be really excessively
  # huge.
  # ========================================================================= #

  # ========================================================================= #
  # === DEFAULT_HEIGHT
  # ========================================================================= #
  DEFAULT_HEIGHT = '550' # default height for an image

  # ========================================================================= #
  # === DEFAULT_WIDTH
  # ========================================================================= #
  DEFAULT_WIDTH  = '550' # default width  for an image

  # ========================================================================= #
  # === USE_THIS_WIDTH_AND_HEIGHT
  # ========================================================================= #
  USE_THIS_WIDTH_AND_HEIGHT = 550

end; end