#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/svg/feature.rb'
# =========================================================================== #
module ImageParadise

module Svg

class Feature # === ImageParadise::Svg::Feature

  attr_accessor :stroke
  attr_accessor :stroke_width
  attr_accessor :fill
  attr_accessor :fill_opacity
  attr_accessor :stroke_opacity
  attr_accessor :style

  # ========================================================================= #
  # === to_svg
  # ========================================================================= #
  def to_svg
    '<overrideme/>'
  end

  # ========================================================================= #
  # === attr_to_s
  # ========================================================================= #
  def attr_to_s(
      attr_name, attr_val
    )
    return '' if attr_val.nil? 
    " #{attr_name}=\"#{attr_val}\"" unless attr_val.to_s.empty?
  end

  # ========================================================================= #
  # === point_to_s
  # ========================================================================= #
  def point_to_s(
      x_attr_name, y_attr_name, point
    )
    return '' if point.nil? 
    return_val = " #{x_attr_name}=\"#{point.x}\"" unless point.x.to_s.empty?
    return_val + " #{y_attr_name}=\"#{point.y}\"" unless point.y.to_s.empty?
  end

end; end; end