#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'create_animated_gif.rb'
# =========================================================================== #
module ImageParadise

  # ========================================================================= #
  # === INPUT_IMAGES_FOR_THE_CREATION_OF_ANIMATED_GIFS
  # ========================================================================= #
  INPUT_IMAGES_FOR_THE_CREATION_OF_ANIMATED_GIFS = '*.gif'

  # ========================================================================= #
  # === DELAY_FOR_THE_CREATION_OF_ANIMATED_GIFS
  # ========================================================================= #
  DELAY_FOR_THE_CREATION_OF_ANIMATED_GIFS = '100'

  # ========================================================================= #
  # === ImageParadise.create_animated_gif
  #
  # This method will create an animated gif.
  #
  # The input should be either an Array of input_images, or a string which
  # will be used to create the command.
  #
  # A delay of 100 means 1 second delay.
  # ========================================================================= #
  def self.create_animated_gif(
      input_images = INPUT_IMAGES_FOR_THE_CREATION_OF_ANIMATED_GIFS,
      delay        = DELAY_FOR_THE_CREATION_OF_ANIMATED_GIFS
    )
    output_name = 'animated_gif.gif'
    _ = 'convert -delay 100 -loop 0 '+input_images+' '+output_name
    esystem _
    e 'Finished creating `'+sfile(output_name)+'`.' if File.exist? output_name
  end

  # ========================================================================= #
  # === create_animated_gif
  # ========================================================================= #
  def create_animated_gif(
      input_images = INPUT_IMAGES_FOR_THE_CREATION_OF_ANIMATED_GIFS,
      delay = DELAY_FOR_THE_CREATION_OF_ANIMATED_GIFS
    )
    ImageParadise.create_animated_gif(input_images, delay)
  end

end