#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/flip_image_left_right.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================= #
  # === ImageParadise.flip_image_left_right
  #
  # This will do a 180° flip action on the image at hand.
  #
  # The new file location will be returned by this method.
  #
  # Note that -density and -quality are probably needed for .jpg, as
  # .jpg loses quality otherwise.
  # ========================================================================= #
  def self.flip_image_left_right(
      this_image, options = {}
    )
    if this_image.is_a? Array
      this_image.each {|entry|
        flip_image_left_right(entry, options)
      }
    else
      unless this_image.include? '/'
        this_image = File.absolute_path(this_image)
      end
      base_dir = File.dirname(this_image)
      # ===================================================================== #
      # Designate a default output-file to use.
      # ===================================================================== #
      name_of_the_output_file = base_dir+'/flipped_image_left_to_right_'+
                                File.basename(this_image)
      if options and !options.empty?
        # =================================================================== #
        # === :use_this_as_the_filepath
        #
        # Designate a file-path to use for the output file.
        # =================================================================== #
        if options.has_key? :use_this_as_the_filepath
          name_of_the_output_file = options[:use_this_as_the_filepath]
        end
      end
      _ = 'convert -density 300 -quality 100 '+this_image+' \( -flop \) +append '+
          name_of_the_output_file
      esystem _
      return name_of_the_output_file
    end
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.flip_image_left_right(ARGV)
end # flipimageleftright