#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/font_related_methods.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================= #
  # === ImageParadise.font_via_tile_pattern
  # ========================================================================= #
  def self.font_via_tile_pattern(
      this_text        = 'Anthony Quinn',
      this_font        = 'Hack-Regular', # 'Hack'
      width_and_height = '500x120'
    )
    store_here = 'output_file.jpg'
    esystem 'convert '\
            '-size '+width_and_height.to_s+' '\
            'xc:lightblue '\
            '-font '+this_font+' '\
            '-pointsize 72 '\
            '-tile pattern:checkerboard '\
            '-annotate +28+68 "'+
            this_text+
            '" '+
            store_here
  end

  # ========================================================================= #
  # === ImageParadise.sheared_shadow_text
  # ========================================================================= #
  def self.sheared_shadow_text(
      this_text        = 'Anthony Quinn',
      this_font        = 'Hack-Regular', # 'Hack'
      width_and_height = '550x150'
    )
    store_here = 'output_file.jpg'
    esystem 'convert '\
            '-size '+width_and_height.to_s+' '\
            'xc:lightblue '\
            '-font '+this_font+' '\
            '-pointsize 50 '\
            '-fill Navy      -annotate 0x0+8+55 "'+this_text.to_s+'" '\
            '-fill RoyalBlue -annotate 0x30+35+90 "'+this_text.to_s+'" '+
            # =============================================================== #
            # Format is:
            #
            #   -annotate XdegreesxYdegrees{+-}tx{+-}ty text
            #
            # =============================================================== #
            store_here
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.font_via_tile_pattern
  ImageParadise.sheared_shadow_text  
end # fontrelatedmethods