#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/interlace.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================= #
  # === ImageParadise.interlace
  #
  # The term "interlace" refers to an image that can be progressively
  # displayed as they are downloaded from a remote location.
  #
  # It was used in the past quite a bit for low-bandwidth connections, to
  # get an indicator as to how the image may look like, before it has been
  # fully download.
  # ========================================================================= #
  def self.interlace(
      i,
      line_or_plane = 'line'
    )
    if i.is_a? Array
      i = i.join(' ').strip
    end
    output_file = 'interlaced_'+File.basename(i)
    _ = 'convert -interlace '+line_or_plane+' '+i+' '+output_file
    esystem _
  end

end # interlace foobar.png