#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/make_this_image_transparent.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================= #
  # === ImageParadise.make_this_image_transparent
  #
  # This method depends on the program called ImageMagick.
  # ========================================================================= #
  def self.make_this_image_transparent(
      i, output_filename = :default
    )
    i = [i].flatten.compact
    array_file_paths = []
    i.each {|this_image|
      base_dir = File.dirname(File.absolute_path(this_image))
      case output_filename
      when :default
        output_filename = base_dir+"/output_#{File.basename(this_image)}"
      end
      _ = 'convert '+this_image+
          ' -transparent white '
      _ << output_filename
      esystem _
      array_file_paths << output_filename
    }
    return array_file_paths
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.make_this_image_transparent(ARGV)
end # make_this_image_transparent