#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/merge_these_images.rb'
# =========================================================================== #
require 'image_paradise/toplevel_methods/esystem.rb'
require 'image_paradise/toplevel_methods/e.rb'

module ImageParadise

  # ========================================================================= #
  # === ImageParadise.merge_these_images
  #
  # This method can be used to merge several input-image files together.
  #
  # This functionality depends on the project called ImageMagick.
  # ========================================================================= #
  def self.merge_these_images(
      i, use_this_as_output_name = 'MERGED_IMAGES'
    )
    i = [i].flatten.compact
    _ = 'convert '.dup
    i.each {|this_image|
      _ << "#{this_image} "
    }
    unless use_this_as_output_name.include? '.'
      # ===================================================================== #
      # In this case we assume that it has no proper end, such as
      # .png or .jpg and so forth.
      # ===================================================================== #
      if use_this_as_output_name.frozen?
        use_this_as_output_name = use_this_as_output_name.dup
      end
      use_this_as_output_name << File.extname(i.first)
    end
    _ << '+append '+use_this_as_output_name
    esystem _
    if File.exist? use_this_as_output_name
      e "Stored as `#{use_this_as_output_name}`."
    end
    return use_this_as_output_name
  end; self.instance_eval { alias merge merge_these_images } # === ImageParadise.merge

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.merge_these_images(ARGV)
end # merge_these_images