#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/png_to_svg.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================== #
  # === ImageParadise.png_to_svg
  #
  # Use this method to convert a .png file to a .svg file.
  #
  # This has several limitations since we use potrace for this.
  #
  # potrace can not work with .png files, only with .pnm files, so
  # we first have to convert these files.
  #
  # The biggest limitation here is that it will remove all colours. :)
  #
  # Usage example:
  #
  #   ImageParadise.png_to_svg 'COOKBOOKS_LOGO.png'
  #
  # ========================================================================== #
  def self.png_to_svg(this_input_file)
    pnm_file = this_input_file.gsub(/\.png$/,'')+'.pnm'
    svg_file = this_input_file.gsub(/\.png$/,'')+'.svg'
    _ = 'convert '+this_input_file+' '+pnm_file
    esystem _
    _ = 'potrace '+pnm_file+' -s -o '+svg_file
    esystem _
    return svg_file
  end; self.instance_eval { alias convert_png_to_svg png_to_svg } # === Imageparadise.convert_png_to_svg

end