#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/resized.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/toplevel_methods/esystem.rb'

  # ========================================================================= #
  # === ImageParadise.resized
  #
  # The second argument is n% resized.
  # ========================================================================= #
  def self.resized(
      i, by_n_percent = '35%',
      output_filename = nil
    )
    unless by_n_percent.is_a? String
      by_n_percent = by_n_percent.to_s
    end
    by_n_percent = by_n_percent.dup
    by_n_percent << '%' unless by_n_percent.end_with? '%'
    if i.is_a? Array
      i = i.join(' ').strip
    end
    case output_filename
    when nil
      output_filename = 'resized_'+File.basename(i)
    end
    _ = 'convert '+i+' -resize '+by_n_percent.to_s+' '+output_filename
    e
    esystem _
    e
    return output_filename # We also return the filename here.
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.resized(ARGV)
end # resized