#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/roebe.rb'
# ImageParadise.is_on_roebe?
# =========================================================================== #
module ImageParadise

  require 'image_paradise/constants/constants.rb'
  require 'image_paradise/toplevel_methods/e.rb'

  # ========================================================================= #
  # === ImageParadise.is_on_roebe?
  # ========================================================================= #
  def self.is_on_roebe?
    ENV['IS_ROEBE'].to_s == '1'
  end

  # ========================================================================= #
  # === ImageParadise.create_file_width_and_height_of_images_in_the_fotogallery
  #
  # This is a custom method for my home system. Other users won't need
  # this really.
  # ========================================================================= #
  def self.create_file_width_and_height_of_images_in_the_fotogallery
    require 'yaml'
    require 'image_paradise/toplevel_methods/misc.rb'
    hash = {}
    all_images = Dir['/home/x/data/images/fotos/**/**'].select {|entry|
      is_an_image?(entry)
    }
    all_images.each {|this_image_file|
      # ======================================================================= #
      # Show some output, as that will take a while to create the .yml file.
      # ======================================================================= #
      e 'Now working on '+this_image_file+' ...'
      width_height = ::ImageParadise.width_height_of_this_image?(this_image_file).to_s
      hash[File.absolute_path(this_image_file)] = width_height
      e '  Width and height is: '+width_height
    }
    # ======================================================================= #
    # The custom file for my home system is stored via the following method:
    # ======================================================================= #
    into = ::ImageParadise.file_width_and_height_of_images_in_the_fotogallery
    what = YAML.dump(hash)
    e "Now storing into #{into}."
    require 'save_file'
    ::SaveFile.write_what_into(what, into)
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.create_file_width_and_height_of_images_in_the_fotogallery
end