#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'image_paradise/toplevel_methods/wallpaper.rb'
# =========================================================================== #
module ImageParadise

  require 'image_paradise/requires/common_base_requires.rb'

  # ========================================================================= #
  # === ImageParadise.wallpaper
  #
  # Use this method if you need to create a wallpaper.
  # ========================================================================= #
  def self.wallpaper(
      colour_to_use = 'black',  # 1st argument: colour to use
      width         = :default, # 2nd argument: width of the image
      height        = :default  # 3rd argument: height of the image
    )
    case width
    when :default
      width = '1980'
    end
    case height
    when :default
      height = '1020'
    end
    if colour_to_use.is_a? Hash
      if colour_to_use.has_key? :colour
        colour_to_use = colour_to_use[:colour]
      end
    end
    _ = "convert -size #{width}x#{height} xc:#{colour_to_use} "\
        "#{colour_to_use}image.png"
    esystem _
  end; self.instance_eval { alias create_image wallpaper } # === ImageParadise.create_image

  # ========================================================================= #
  # === ImageParadise.white_wallpaper
  # ========================================================================= #
  def self.white_wallpaper(width = :default, height = :default)
    wallpaper(:white, width, height)
  end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise.wallpaper
  ImageParadise.white_wallpaper
end