#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === ImageParadise::BlackWhite
#
# This class can turn an image into a black-white image.
#
# Usage example:
#
#   ImageParadise::BlackWhite.new
#
# =========================================================================== #
# require 'image_paradise/utility_scripts/black_white.rb'
# ImageParadise::BlackWhite.new(ARGV)
# =========================================================================== #
require 'image_paradise/base/base.rb'

module ImageParadise

class BlackWhite < ::ImageParadise::Base # === ImageParadise::BlackWhite

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize(
      i           = nil,
      run_already = true
    )
    reset
    set_input(i)
    run if run_already
  end

  # ========================================================================= #
  # === reset                                                     (reset tag)
  # ========================================================================= #
  def reset
  end

  # ========================================================================= #
  # === set_input
  # ========================================================================= #
  def set_input(i = ARGV)
    i = [i] unless i.is_a? Array
    @input = i
  end

  # ========================================================================= #
  # === input?
  # ========================================================================= #
  def input?
    @input
  end

  # ========================================================================= #
  # === run                                                         (run tag)
  # ========================================================================= #
  def run
    input?.each {|filename|
      _ = 'convert '+filename+' -colorspace Gray OUTPUT_'+filename
      Esystem.esystem(_)
    }
  end

  # ========================================================================= #
  # === ImageParadise::BlackWhite[]
  # ========================================================================= #
  def self.[](i = '')
    new(i)
  end

end

# =========================================================================== #
# === ImageParadise.black_white
# =========================================================================== #
def self.black_white(i = ARGV)
  if i.is_a? Array
    i.each {|entry|
      ImageParadise.black_white(entry)
    }
  else
    ImageParadise::BlackWhite.new(i)
  end
end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise::BlackWhite.new(ARGV)
end # blackwhite