#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === ImageParadise::ToJpg
#
# This class will simply convert an image file to .jpg format.
#
# Usage example:
#
#   ImageParadise::ToJpg.new(ARGV)
#
# =========================================================================== #
# require 'image_paradise/to_jpg.rb'
# ImageParadise.:ToJpg.new(ARGV)
# =========================================================================== #
require 'image_paradise/base/base.rb'

module ImageParadise

class ToJpg < ::ImageParadise::Base # === ImageParadise::ToJpg

  # ========================================================================= #
  # === NAMESPACE
  # ========================================================================= #
  NAMESPACE = inspect

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize(
      i           = ARGV,
      run_already = true
    )
    reset
    set_commandline_arguments(i)
    run if run_already
  end

  # ========================================================================= #
  # === reset                                                     (reset tag)
  # ========================================================================= #
  def reset
    # ======================================================================= #
    # === @namespace
    # ======================================================================= #
    @namespace = NAMESPACE
  end

  # ========================================================================= #
  # === return_where_to_store_this
  # ========================================================================= #
  def return_where_to_store_this(i)
    i.gsub(File.extname(i),'')+
    '.jpg' # Store as .jpg, logically.
  end

  # ========================================================================= #
  # === run_everything
  # ========================================================================= #
  def run_everything
    commandline_arguments?.each {|this_file|
      store_where = return_where_to_store_this(this_file)
      opnn; e 'Next converting '+simp(this_file)+' to '+sfile(store_where)
      _ = 'convert '+this_file+' '+store_where
      esystem _
    }
  end

  # ========================================================================= #
  # === run                                                         (run tag)
  # ========================================================================= #
  def run
    run_everything
  end

end

# =========================================================================== #
# === ImageParadise.to_jpg
# =========================================================================== #
def self.to_jpg(i = ARGV)
  ImageParadise::ToJpg.new(i)
end

end

if __FILE__ == $PROGRAM_NAME
  ImageParadise::ToJpg.new(ARGV)
end # tojpg